# jQuery & javascript extensions

## Adds following to __window__ variable:
- ### __log__: which is a shortcut for console.log
- ### __$__ and __jQuery__: the jquery's famous $ and jQuery variable
- ### __stackTrace function() -> Error__: returns an error object containing current stack trace
- ### __logStackTrace function() -> void__: prints current stack trace in console

## Adds the following methods to any __jQuery__ variable:
- ### __hasAttr function (name) -> Boolean__: checks if a jquery object has the given attribute.
    > $('.test').hasAttr('id')
- ### __equals function(jQueryObject) -> Boolean__: checks if a jquery object equals the given jquery object. 
    > $('.test').equals($('.test'))
- ### __outerHTML function() -> String__: returns the jquery object's outer html.
    > $('.test').outerHTML()

## Adds the following methods to javascript __Number__:
- ### __padZero function(size) -> String__: inserts 0s before a number until the length is equal to _size_ parameter
    > var x = 123; <br/>
    > x.padZero(5) <br/>
    > prints: 00123
- ### __format function(separator = ',') -> String__: thousand separator for mostly currencies
    > var x = 123000; <br>
    > x.format('/') <br>
    > prints: 123/000
## Adds the following methods to javascript __String__:
- ### __format function(templateString, ...args)__: just like c# String.format
    > String.format('Hi, {0}', 'Akbar') <br/>
    > prints: Hi, Akbar
## Adds the following to __FormData__:
- ### __print function() -> String__: prints FormData object
- ### __put function(object) -> FormData__: puts all properties of object recursively into FormData
## jQuery __classes__ polyfill for IE 
### will be automatically injected on import
## __IE10 viewport__ hack for Surface/desktop Windows 8 bug
### will be automatically injected on import
## fix for __safari__ bug on __readonly input__
### will be automatically injected on import